SchoolProject/Models/ClassViewModel.cs
using Data.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Linq.Expressions;
using System.Web;

namespace SchoolProject.Models
{
    public class ClassViewModel
    {
        public int Id { get; set; }

        [StringLength(60, MinimumLength = 1)]
        [Display(Name = "Name")]
        public string Name { get; set; }

        public static Expression<Func<Class, ClassViewModel>> Projection
        {
            get
            {
                return p => new ClassViewModel()
                {
                    Id = p.Id,
                    Name = p.Name
                };
            }
        }

        public static ClassViewModel CreateViewModel(Class classModel)
        {
            return Projection.Compile().Invoke(classModel);
        }
    }
}

SchoolProject/Models/StudentViewModel.cs
using Data.Models;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Linq.Expressions;
using System.Web;

namespace SchoolProject.Models
{
    public class StudentViewModel
    {
        public int Id { get; set; }

        [StringLength(60, MinimumLength = 3)]
        [Display(Name = "First Name")]
        public string FirstName { get; set; }

        [StringLength(60, MinimumLength = 3)]
        [Display(Name = "Last Name")]
        public string LastName { get; set; }

        public int Age { get; set; }

        [StringLength(60, MinimumLength = 1)]
        [Display(Name = "Class Name")]
        public string ClassName { get; set; }

        public static Expression<Func<Student, StudentViewModel>> Projection
        {
            get
            {
                return p => new StudentViewModel()
                {
                    Id = p.Id,
                    FirstName = p.FirstName,
                    LastName = p.LastName,
                    Age = p.Age,
                    ClassName = p.Class.Name
                };
            }
        }

        public static StudentViewModel CreateViewModel(Student student)
        {
            return Projection.Compile().Invoke(student);
        }
    }
}

SchoolProject/Controllers/ClassController.cs
using Data.Context;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Data.Repositories.Interfaces;
using Data.Models;
using SchoolProject.Models;

namespace SchoolProject.Controllers
{
    public class ClassController : Controller
    {
        private readonly IClassRepository _classRepository;

        public ClassController(IClassRepository classRepository)
        {
            _classRepository = classRepository;
        }

        public ActionResult GetClasses()
        {
            var classEntities = _classRepository.GetAllClasses();

            return View(classEntities);
        }

        public ActionResult AddClass()
        {
            if (TempData["Failed"] != null)
            {
                ViewBag.Failed = "Add Class Failed";
            }
            return View();
        }

        [HttpPost]
        public ActionResult AddClass(ClassViewModel model)
        {
            if (ModelState.IsValid)
            {
                var newClass = new Class()
                {
                    Name = model.Name
                };
                int result = _classRepository.AddClass(newClass);
                if (result > 0)
                {
                    return RedirectToAction("GetClasses", "Class");
                }
                else
                {
                    TempData["Failed"] = "Failed";
                    return RedirectToAction("AdClass", "Class");
                }
            }
            return View();
        }

        public PartialViewResult EditClass(int id)
        {
            if (TempData["Failed"] != null)
            {
                ViewBag.Failed = "Edit Employee Failed";
            }
            var viewModel = ClassViewModel.CreateViewModel(_classRepository.GetClassById(id));

            return PartialView(viewModel);
        }

        [HttpPost]
        public ActionResult EditClass(int id, ClassViewModel model)
        {
            if (ModelState.IsValid)
            {
                var newClass = new Class()
                {
                    Name = model.Name
                };
                int result = _classRepository.UpdateClass(id, newClass);
                if (result > 0)
                {
                    return RedirectToAction("GetClasses", "Class");
                }
                else
                {

                    return RedirectToAction("GetClasses", "Class");
                }
            }
            return PartialView();
        }


        public ActionResult DeleteClass(int classId)
        {
            Class model = _classRepository.GetClassById(classId);
            return View(model);
        }

        [HttpPost]
        public ActionResult DeleteClass(Class model)
        {
            if (TempData["Failed"] != null)
            {
                ViewBag.Failed = "Delete Employee Failed";
            }
            _classRepository.DeleteClass(model.Id);
            return RedirectToAction("GetClasses", "Class");
        }

    }
}

SchoolProject/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace SchoolProject.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}

SchoolProject/Controllers/StudentController.cs
using Data.Repositories.Interfaces;
using SchoolProject.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace SchoolProject.Controllers
{
    public class StudentController : Controller
    {
        private readonly IStudentRepository _studentRepository;

        public StudentController(IStudentRepository studentRepository)
        {
            _studentRepository = studentRepository;
        }

        public ActionResult GetStudents()
        {
            var students = _studentRepository.GetAllStudents();

            List<StudentViewModel> studentViewModels = new List<StudentViewModel>();

            foreach(var student in students)
            {
                studentViewModels.Add(StudentViewModel.CreateViewModel(student));
            }

            return View(studentViewModels);
        }

        [HttpGet, Route("{id}")]
        public ActionResult GetAllStudentsByClass(int id)
        {
            var students = _studentRepository.GetAllStudentsByClass(id);
            return View(students);
        }
    }
}

SchoolProject/Views/Class/AddClass.cshtml
@model SchoolProject.Models.ClassViewModel

@using (Html.BeginForm("AddClass", "Class", FormMethod.Post))
{
    
        @Html.AntiForgeryToken()

        <div class="form-horizontal">
            <hr />
            @Html.ValidationSummary(true, "", new { @class = "text-danger" })
            <div class="form-group">
                @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">
                    @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
                </div>
            </div>

            <div class="form-group">
                <div class="col-md-offset-2 col-md-10">
                    @*<input type="submit" value="Create" class="btn btn-default" />*@
                    <input type="submit" value="Create" class="btn btn-default" onclick="location.href='@Url.Action("AddClass", "Class", new { model = Model })'" />
                </div>
            </div>
        </div>
    

}

    @section Scripts {
        @Scripts.Render("~/bundles/jqueryval")
    }

SchoolProject/Views/Class/EditClass.cshtml
@model SchoolProject.Models.ClassViewModel


@using (Html.BeginForm("EditClass", "Class", FormMethod.Post))
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.Id)

        <div class="form-group">
            @Html.LabelFor(model => model.Name, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Name, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Name, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
}

SchoolProject/Views/Class/GetClasses.cshtml
@model IEnumerable<Data.Models.Class>
<br />
<br />
<div class="row" style="font-family:Verdana;">
    <div class="col-md-4">
    </div>
    <div class="col-md-4">
        <br />

        <p>
            <div>
                <input type="button" id="btn" class="btn btn-outline-dark" value="Create New">
            </div>
            <div id="Show" style="display:none">
                @Html.Partial("~/Views/Class/AddClass.cshtml", new SchoolProject.Models.Classes.ClassViewModel())
            </div>
        </p>

        <br />
        <table class="table table-borderless" style="font-family:Verdana;">
            <tr>
                <th>
                    @Html.DisplayNameFor(model => model.Name)
                </th>
                <th></th>
            </tr>

            @foreach (var item in Model)
            {
                <tr>
                    <td>
                        <button type="button" class="btn btn-link" onclick="location.href='@Url.Action("GetAllStudentsByClass", "Student", new { id = item.Id })'">@item.Name</button>
                    </td>
                    <td>
                        <button id="button" class="btn btn-outline-info" onclick="showhide()">Edit</button>
                        <div id="ShowHide" style="display:none">
                            @{Html.RenderAction("EditClass", "Class", new { id = item.Id });}
                        </div>
                        <button type="button" class="btn btn-outline-info" onclick="location.href='@Url.Action("DeleteClass", "Class", new { id = item.Id })'">Delete</button>

                    </td>
                </tr>
            }
        </table>
    </div>
</div>


@section Scripts{
    <script type="text/javascript">
        $(document).ready(function () {
            $("#btn").click(function () {
                $("#Show").toggle();
            });
        });
    </script>
    <script>
        function showhide() {
            var div = document.getElementById("ShowHide");
            if (div.style.display !== "none") {
                div.style.display = "none";
            }
            else {
                div.style.display = "block";
            }
        }
    </script>
}

SchoolProject/Views/Home/About.cshtml
@{
    ViewBag.Title = "About";
}
<h2>@ViewBag.Title.</h2>
<h3>@ViewBag.Message</h3>

<p>Use this area to provide additional information.</p>

SchoolProject/Views/Home/Contact.cshtml
@{
    ViewBag.Title = "Contact";
}
<h2>@ViewBag.Title.</h2>
<h3>@ViewBag.Message</h3>

<address>
    One Microsoft Way<br />
    Redmond, WA 98052-6399<br />
    <abbr title="Phone">P:</abbr>
    425.555.0100
</address>

<address>
    <strong>Support:</strong>   <a href="mailto:Support@example.com">Support@example.com</a><br />
    <strong>Marketing:</strong> <a href="mailto:Marketing@example.com">Marketing@example.com</a>
</address>

SchoolProject/Views/Home/Index.cshtml
@{
    ViewBag.Title = "Home Page";
}
<br /><br />
    <h1 style="font-family:Verdana; color: #4d4d4d">
        Welcome to my school project! If you want to see all the classes, please click
        @Html.ActionLink("here", "GetClasses", "Class"). :)
    </h1>

    @*<div id="Show" style="display:none">
        @Html.Partial("~/Views/Class/GetClasses.cshtml")

    </div>

@section Scripts{
    <script type="text/javascript">
        $(document).ready(function () {
            $("#btn").click(function () {
                $("#Show").toggle();
            });
        });
    </script>
}*@

SchoolProject/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - My ASP.NET Application</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")
</head>
<body>
    <div class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                @Html.ActionLink("School project", "Index", "Home", new { area = "" }, new { @class = "navbar-brand" })
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li>@Html.ActionLink("Home", "Index", "Home")</li>
                    <li>@Html.ActionLink("Classes", "GetClasses", "Class")</li>
                    <li>@Html.ActionLink("Students", "GetStudents", "Student")</li>
                </ul>
            </div>
        </div>
    </div>
    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>&copy; @DateTime.Now.Year - My ASP.NET Application</p>
        </footer>
    </div>

    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap")
    @RenderSection("scripts", required: false)
</body>
</html>

SchoolProject/Views/Student/GetAllStudentsByClass.cshtml
@model IEnumerable<Data.Models.Student>

<p>
    @Html.ActionLink("Create New", "Create")
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.Class.Name)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.FirstName)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.LastName)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Age)
        </th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.Class.Name)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.FirstName)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.LastName)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Age)
        </td>
        <td>
            @Html.ActionLink("Edit", "Edit", new { id=item.Id }) |
            @Html.ActionLink("Delete", "Delete", new { id=item.Id })
        </td>
    </tr>
}

</table>

SchoolProject/Views/Student/GetStudents.cshtml
@model IEnumerable<SchoolProject.Models.StudentViewModel>


<p>
    @Html.ActionLink("Create New", "Create")
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.FirstName)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.LastName)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Age)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.ClassName)
        </th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.FirstName)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.LastName)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Age)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.ClassName)
        </td>
        <td>
            @Html.ActionLink("Edit", "Edit", new { id=item.Id }) |
            @Html.ActionLink("Delete", "Delete", new { id=item.Id })
        </td>
    </tr>
}

</table>